//p-180.cs

AddDamageType("p180",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(p180Projectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 20;
   directDamageType    = $DamageType::p180;
   radiusDamageType    = $DamageType::p180;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.10;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "P-180 Bullet";
};

//////////
// item //
//////////
datablock ItemData(p180Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./p-180item.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "P-180";
	iconName = "./icon_p180";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = p180Image;
	canDrop = true;

	maxAmmo = 15;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(p180Image)
{
   // Basic Item properties
   shapeFile = "./p-180.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = p180Item;
   ammo = " ";
   projectile = p180Projectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = gunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.15;
	stateSequence[0]		= "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			= weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNoAmmo[1]	= "ReloadStart";
	stateTransitionOnTriggerDown[1] = "Fire";
	stateAllowImageChange[1]        = true;
	stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateSequence[2]		= "Fire";
	stateWaitForTimeout[2]		= true;
	stateEmitter[2]			= gunFlashEmitter;
	stateEmitterTime[2]		= 0.05;
	stateEmitterNode[2]		= "muzzleNode";
	stateSound[2]			= gunShot1Sound;

	stateName[3] 			= "Smoke";
	stateEmitter[3]			= gunSmokeEmitter;
	stateEmitterTime[3]		= 0.1;
	stateEmitterNode[3]		= "muzzleNode";
	stateTransitionOnTriggerUp[3] = "Wait";

	stateName[4]			= "Wait";
	stateEjectShell[2]              = true;
	stateTimeoutValue[4]		= 0.001;
	stateScript[4]                  = "onBounce";
	stateTransitionOnTimeout[4]	= "LoadCheckA";
	stateSound[4]			= weaponSwitchSound;
	
	//Torque switches states instantly if there is an ammo/noammo state, regardless of stateWaitForTimeout
	stateName[5]				= "LoadCheckA";
	stateScript[5]				= "onLoadCheck";
	stateTimeoutValue[5]			= 0.01;
	stateTransitionOnTimeout[5]		= "LoadCheckB";
	
	stateName[6]				= "LoadCheckB";
	stateTransitionOnAmmo[6]		= "Ready";
	stateTransitionOnNoAmmo[6]		= "ReloadWait";
	
	stateName[7]				= "ReloadWait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "";
	stateTransitionOnTimeout[7]		= "ReloadStart";
	stateWaitForTimeout[7]			= true;
	
	stateName[8]				= "ReloadStart";
	stateTimeoutValue[8]			= 1.1;
	stateScript[8]				= "onReloadStart";
	stateTransitionOnTimeout[8]		= "Reloaded";
	stateWaitForTimeout[8]			= true;
	stateSound[8]				= Block_MoveBrick_Sound;
	
	stateName[9]				= "Reloaded";
	stateTimeoutValue[9]			= 0.3;
	stateScript[9]				= "onReloaded";
	stateTransitionOnTimeout[9]		= "Ready";
	stateSound[9]				= Block_PlantBrick_Sound;
};



function p180Image::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() >= 1.0)
		return;
	
	if(vectorLen(%obj.getVelocity()) > 0.1)
	{
		%this.raycastSpreadAmt = 0.0018;
		%this.raycastWeaponRange = 85;
	}
	else
	{
		%this.raycastSpreadAmt = 0.0009;
		%this.raycastWeaponRange = 200;
	}
	
	if(%obj.toolAmmo[%obj.currTool] > 0)
	{
    if(%obj.client.quantity["ReloadAmmop180"] < 1)
    {
    %obj.client.quantity["ReloadAmmop180"] = 0;
    }

	%projectile = p180Projectile;
	%spread = 0.000001;
	%shellcount = 1;

		%obj.toolAmmo[%obj.currTool]--;
        %obj.client.quantity["ReloadCountp180"] += 1; //Add one to how much they can reload
        commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmop180"] @ "", 1, 2, 3, 4);
		Parent::onFire(%this,%obj,%slot);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	    %obj.playThread(2, shiftAway);
	}
	return %p; 
	}
	else if(%this.item.maxAmmo == 0)
	{
		Parent::onFire(%this,%obj,%slot);
	}

		Parent::onFire(%this,%obj,%slot);
	
		
}

function p180Image::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmop180"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | 0", 1, 2, 3, 4);
    return;
    }

	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, activate);
}

function p180Image::onBounce(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmop180"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | 0", 1, 2, 3, 4);
    return;
    }

	%obj.playThread(2, plant);
}

function p180Image::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmop180"] >= 1)
        {
        if(%obj.client.quantity["ReloadAmmop180"] >= 15)
            {
            %obj.client.quantity["ReloadAmmop180"] -= %obj.client.quantity["ReloadCountp180"];
	        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;          //%this.item.maxAmmo
	        %obj.setImageAmmo(%slot,1);
            if(%obj.client.quantity["ReloadAmmop180"] < 1)
            {
            %obj.client.quantity["ReloadAmmop180"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 16)
            {
            %obj.toolAmmo[%obj.currTool] = 15;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: 15 | " @ %obj.client.quantity["ReloadAmmop180"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["ReloadCountp180"] = 0;
	        %obj.playThread(2, plant);
            }
        else
            {
	        %obj.toolAmmo[%obj.currTool] += %obj.client.quantity["ReloadAmmop180"];  
	        %obj.setImageAmmo(%slot,1);
            %obj.client.quantity["ReloadAmmop180"] = 0;
            if(%obj.client.quantity["ReloadAmmop180"] < 1)
            {
            %obj.client.quantity["ReloadAmmop180"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 16)
            {
            %obj.toolAmmo[%obj.currTool] = 15;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmop180"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["ReloadCountp180"] = 0;
	        %obj.playThread(2, plant);
            }
        }
    else
        {
        messageClient(%client,'','\c3You don\'t have any Ammo to reload with!');
        }
}

function p180Image::onMount(%this,%obj,%slot) { parent::onMount(%this,%obj,%slot); %obj.hideNode("LHand"); %obj.hideNode("RHand"); %obj.hideNode("LHook"); %obj.hideNode("RHook"); }
function p180Image::onUnMount(%this,%obj,%slot) { parent::onUnMount(%this,%obj,%slot); %obj.unhideNode("LHand"); %obj.unhideNode("RHand"); }

registerOutputEvent("Player", "P180RefillAmmo");

function Player::P180RefillAmmo(%obj, %client)
{
    %obj.toolAmmo[%obj.currTool] = 15;
    %obj.client.quantity["ReloadAmmop180"] = 45;
    %obj.client.quantity["ReloadCountp180"] = 0;
	%obj.playThread(2, plant);
    commandToClient(%obj.client,'centerPrint',"<just:right>\c6P-180 Ammo Refilled!", 1, 2, 3, 4);  
}