/////////////////////////////////////////////
//Name: ACR                                //
//Authors: Chao and Hans "Super Chao" Arne //
//Version: 1                               //
/////////////////////////////////////////////

AddDamageType("ACR",   '<bitmap:add-ons/Weapon_Gun/CI_gun> %1',    '%2 <bitmap:add-ons/Weapon_Gun/CI_gun> %1',0.2,1);
datablock ProjectileData(ACRProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 19;
   directDamageType    = $DamageType::ACR;
   radiusDamageType    = $DamageType::ACR;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 0;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "ACR Bullet";
};

//////////
// item //
//////////
datablock ItemData(ACRItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./ACRitem.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "ACR";
	iconName = "./icon_ACR";
	doColorShift = true;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = ACRImage;
	canDrop = true;

	maxAmmo = 30;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ACRImage)
{
   // Basic Item properties
   shapeFile = "./ACR.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ACRItem;
   ammo = " ";
   projectile = ACRProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = ACRItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
    stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.05;
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  = true;
	stateEmitter[2]					= gunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= gunshot1Sound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.03;
	stateEmitter[3]					= gunSmokeEmitter;
	stateEmitterTime[3]				= 0.03;
	stateEmitterNode[3]				= "muzzleNode";
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.2;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	stateWaitForTimeout[6]			= true;
	stateSound[6]				= Block_MoveBrick_Sound;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.8;
	stateSound[7]				= weaponSwitchSound;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.1;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	stateEmitter[10]			= gunSmokeEmitter;
	stateEmitterTime[10]			= 0.3;
	stateEmitterNode[10]			= "muzzleNode";
	stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Ready";
	stateTransitionOnTriggerDown[10]	= "Fire";
	
	stateName[11] 				= "ReloadSmoke";
	stateEmitter[11]			= gunSmokeEmitter;
	stateEmitterTime[11]			= 0.3;
	stateEmitterNode[11]			= "muzzleNode";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";
};

function ACRImage::onReloadStart(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
//	%obj.toolAmmo[%obj.currTool] = 0;
	%obj.playThread(2, wrench);
}

function ACRImage::onReloadWait(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmo"] == 0)
    {
    commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmo"] @ "", 1, 2, 3, 4);
    return;
    }
	%obj.playThread(2, activate);
}

function ACRImage::onReloaded(%this,%obj,%slot)
{
    if(%obj.client.quantity["ReloadAmmo"] >= 1)
        {
        if(%obj.client.quantity["ReloadAmmo"] >= 30)
            {
            %obj.client.quantity["ReloadAmmo"] -= %obj.client.quantity["ReloadCount"];
	        %obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;          //%this.item.maxAmmo
	        %obj.setImageAmmo(%slot,1);
            if(%obj.client.quantity["ReloadAmmo"] < 1)
            {
            %obj.client.quantity["ReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 31)
            {
            %obj.toolAmmo[%obj.currTool] = 30;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: 30 | " @ %obj.client.quantity["ReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["ReloadCount"] = 0;
            }
        else
            {
	        %obj.toolAmmo[%obj.currTool] += %obj.client.quantity["ReloadAmmo"];  
	        %obj.setImageAmmo(%slot,1);
            %obj.client.quantity["ReloadAmmo"] = 0;
            if(%obj.client.quantity["ReloadAmmo"] < 1)
            {
            %obj.client.quantity["ReloadAmmo"] = 0;
            }
            if(%obj.toolAmmo[%obj.currTool] >= 31)
            {
            %obj.toolAmmo[%obj.currTool] = 30;
            }
            commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmo"] @ "", 1, 2, 3, 4); 
            %obj.client.quantity["ReloadCount"] = 0;
            }
        }
    else
        {
        messageClient(%client,'','\c3You don\'t have any Ammo to reload with!');
        }
}

function ACRImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}

function ACRImage::onFire(%this,%obj,%slot)
{
	%projectile = ACRProjectile;
	%spread = 0.005;
	%shellcount = 1;

    if(%obj.client.quantity["ReloadAmmo"] < 1)
    {
    %obj.client.quantity["ReloadAmmo"] = 0;
    }

      %obj.toolAmmo[%obj.currTool]--;
	  %obj.playThread(2, plant);
	  %shellcount = 1;
      %obj.client.quantity["ReloadCount"] += 1; //Add one to how much they can reload
      commandToClient(%obj.client,'bottomPrint',"<just:right>\c6Ammo: " @ %obj.toolAmmo[%obj.currTool] @ " | " @ %obj.client.quantity["ReloadAmmo"] @ "", 1, 2, 3, 4);
  
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 2 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p; 
}

function ACRImage::onMount(%this,%obj,%slot) { parent::onMount(%this,%obj,%slot); %obj.hideNode("LHand"); %obj.hideNode("RHand"); %obj.hideNode("LHook"); %obj.hideNode("RHook"); }
function ACRImage::onUnMount(%this,%obj,%slot) { parent::onUnMount(%this,%obj,%slot); %obj.unhideNode("LHand"); %obj.unhideNode("RHand"); }

registerOutputEvent("Player", "ACRRefillAmmo");

function Player::ACRRefillAmmo(%obj, %client)
{
    %obj.toolAmmo[%obj.currTool] = 30;
    %obj.client.quantity["ReloadAmmo"] = 60;
    %obj.client.quantity["ReloadCount"] = 0;
	%obj.playThread(2, plant);
    commandToClient(%obj.client,'centerPrint',"<just:right>\c6ACR Ammo Refilled!", 1, 2, 3, 4);  
}